local amountposts = -1
local pastlastpost = false
local processed = false
local timer = 3*TICRATE
local jingleheadertoggle = true
local finishplayed = false

addHook("MapLoad", do
	if multiplayer
		processed = false
		timer = 3*TICRATE
		jingleheadertoggle = true
		finishplayed = false
		amountposts = -1
		pastlastpost = false
	end
end)

addHook("MobjThinker", function(mo)
	if (gametyperules | GTR_RACE and circuitmap == false)
		amountposts = max(amountposts, mo.health)
	end
end, MT_STARPOST)

addHook("TouchSpecial", function(special, mo)
	if (gametyperules | GTR_RACE and circuitmap == false)
		if mo.player and (special.type == MT_STARPOST)
			mo.player.startouch = special.health
			if (mo.player.startouch == amountposts)
				pastlastpost = true
			end
		end
	end
end, MT_STARPOST)

addHook("ThinkFrame", do
	if multiplayer
		if (gametyperules | GTR_RACE)
			if not circuitmap
				for player in players.iterate()
					if (player and player.mo and player.mo.valid)
						if (processed == false and pastlastpost)
							if (jingleheadertoggle == true)
								chatprint("\x82* "..player.name.."\x80 passed the\x85 final Star Post\x80!")
								S_StartMusicCaption("Final lap!", 3*TICRATE, player)
								S_ChangeMusic("FINLAP", false, player)
								jingleheadertoggle = false
							end
							if timer == 0
								P_RestoreMusic(player)
								processed = true
							end
							timer = timer - 1
						elseif (processed and finishplayed == false)
							S_SetMusicPosition(S_GetMusicPosition() + 5)
						end
						if (player.exiting ~= 0 and finishplayed == false)
							S_StartSound(nil, sfx_finish, player)
							S_ChangeMusic("_INTER", true, player)
							finishplayed = true
						end
					end
				end
			end
		end
	end
end)